#ifdef HAVE_CONFIG_H
#include "config.h"
#endif /* HAVE_CONFIG_H */

#ifdef HAVE_EXPAT_H
# include <expat.h>
#elif HAVE_XMLPARSE_H
# include <xmlparse.h>
#else /* HAVE_XMLPARSE_H / !HAVE_XMLPARSE_H */
#error no expat.h or xmlparse.h found
#endif /* !HAVE_XMLPARSE_H */

#define MAXDEPTH 100


#define START(NAME) void NAME##_start_handler(const XML_Char *name, const XML_Char **attr)
#define END(NAME) void NAME##_end_handler(const XML_Char *name)
#define DATA(NAME) void NAME##_data_handler(void *userdata, const XML_Char *s, int len)

typedef void (*StartHandler)(const XML_Char *name, const XML_Char **attr);
typedef void (*EndHandler)(const XML_Char *name);
/* typedef void (*DataHandler)(const XML_Char *s, int len); */
typedef XML_CharacterDataHandler DataHandler;

typedef struct {
  StartHandler starthandler;
  EndHandler   endhandler;
  DataHandler  datahandler;
} Handlers;

typedef struct {
  char *str;
  size_t len;
} TempBuffer;


void find_handlers(const char *, Handlers *);
void wait_for_start_tag(const XML_Char *name);
void wait_for_end_tag(const XML_Char *name);

void set_output_to_temp_buffer(TempBuffer *buf);
void unset_output_to_temp_buffer();
